*:********************************************************************
*:
*:	Procedure file: findproj.prg
*:	Contents:
*:		Procedure:	FindInFile
*:		Procedure:	FindInMemo
*:		Procedure:	Progress
*:		Class :		FindForm as Form
*:			Method:	Init
*:			Method:	List.Init
*:			Method:	List.DblClick
*:			Method:	Resize
*:		Class :		ProgressBar as CommCtrl
*:			Method:	Show
*:			Method:	Min_Assign
*:			Method:	Max_Assign
*:			Method:	SetStep
*:			Method:	Clear
*:			Method:	StepIp
*:			Method:	BackColor
*:			Method:	BarColor
*:			Method:	Value
*:			Method:	VFPStatusHwnd
*:		Class :		CommCtrl as Custom
*:			Method:	Init
*:			Method:	Show
*:			Method:	CreateWindow
*:			Method:	GetParentHWND
*:			Method:	SendMessage
*:			Method:	Destroy
*:			Method:	C2B
*:			Method:	LoadDLLS
*:		Class :		ProgressForm as Form
*:			Method:	Init
*:			Method:	text_assign
*:			Method:	value_assign
*:
*: Piva BEAR v.200 format 28.03.2006 09:53
*:********************************************************************
* Find String in Project
*
*
Lparameters lcPJX, lcFindStr
_FONTNAME='Tahoma'

Declare Integer GetUserDefaultLCID In Win32Api
LCID=GetUserDefaultLCID()
Do Case
Case LCID=1049
	LOC_TITLE="  "
	LOC_INPUTBOX_PROMPT="   "
	LOC_PROGRESS_TEXT=["  "+lcFindStr+" ..."]
	LOC_FORM_CAPTION=['   "'+lcFindStr+'"   '+JustFname(lcPjx)]
	LOC_CONTENT=""
	LOC_CLASS=""
	LOC_METHOD=""
	LOC_LINE=""
	LOC_CODE=""
	LOC_ERR=["    "+Transform(nErr)+".     EditSource"]
	
	Otherwise
	
	LOC_TITLE="Find in Project"
	LOC_INPUTBOX_PROMPT="Search string in project"
	LOC_PROGRESS_TEXT=["Searching "+lcFindStr+" ..."]
	LOC_FORM_CAPTION=['Search result string "'+lcFindStr+'" in project '+JustFname(lcPjx)]
	LOC_CONTENT="File"
	LOC_CLASS="Class"
	LOC_METHOD="Nethod"
	LOC_LINE="Line"
	LOC_CODE="Source code"
	LOC_ERR=["Error execute EditSource # "+Transform(nErr)+". See Help for details"]
	
Endcase

If Empty(lcPJX) Or Empty(lcFindStr)
	lcPJX=Getfile("PJX")
	If Empty(lcPJX)
		Return .F.
	Endif
Endif
If Empty(lcFindStr)
	lcFindStr=Inputbox(LOC_INPUTBOX_PROMPT,LOC_TITLE,"")
	If Empty(lcFindStr)
		Return .F.
	Endif
Endif
lcPJX=Fullpath(lcPJX)
If Not File(lcPJX)
	Error 1,lcPJX
	Return .F.
Endif

Private lcFileName
Local lcAlias, lcTmp, lcProcCursor

*       
* Temporary alias
lcAlias=Sys(2015)

*      
* Temp File Name
lcTmp=Addbs(Sys(2023))+Substr(Sys(2015),3,8)+'.tmp'

***     
Use (lcPJX) Again In Select(lcAlias) Shared Noupdate Alias (lcAlias)
If Not Used(lcAlias)
	Return .F.
Endif
Select * From (lcPJX) Into Cursor Project NoFilter
Use In Select(lcAlias)

*  
lcProcCursor=Sys(2015)
Create Cursor (lcProcCursor) (content c(128), Line i, Type c(20), indent i)

*      
*      EditSource
Create Cursor Result ;
( Name 		m;
, method 	m;
, Class 	m;
, Line 		i;
, Code 		m;
)

m.HomePath=Addbs(Justpath(lcPJX))


Local oPrg
oPrg=Progress(0,Evaluate(LOC_PROGRESS_TEXT),LOC_TITLE)

Select Project
Scan All
	oPrg.Value=Recno()/Reccount()
	
	*   = sys(2014)     chr(0)
	lcFileName=Project.Name
	lcFileName=Fullpath(lcFileName,m.HomePath)
	Do Case
		*      Query  MPR
	Case ;
		Project.Type=='P' ;
		or Project.Type=='T' ;
		or Project.Type=='Q' ;
		or Project.Type=='m'
		
		FindInFile(lcFileName, lcFindStr)
		
		* VCX + SCX = Visual Class Library and Screen Forms (or ProjectHook)
	Case Project.Type=='V' Or Project.Type=='K' Or Project.Type=='W'
		Select 0
		Use (lcFileName) Alias (lcAlias) Again
		Select (lcAlias)
		Scan All
			If Not Empty(Methods)
				*     
				Strtofile(Methods,lcTmp)
				lnProc=Aprocinfo(aMethod,lcTmp)
				Select (lcAlias)
				
				k=Alines(tmp,Methods)
				For i=1 To k
					
					If Atc(lcFindStr,tmp[i])>0
						lcCode=tmp[i]
						lcMethod=""
						lnLine=i
						l=0
						For N=1 To Alen(aMethod,1)
							*      - 
							If aMethod[n,2]>i
								Exit
							Else
								*
								lcMethod=aMethod[n,1]
								lnLine=i-aMethod[n,2]
							Endif
						Next
						lcClass=objname
						*   EditSource
						If Not Empty(Parent)
							If '.' $ Parent
								lcClass=Left(Parent,At('.',Parent)-1)
								lcMethod=Substr(Parent,At('.',Parent)+1)+"."+objname+"."+lcMethod
							Else
								lcClass=Parent
								lcMethod=objname+"."+lcMethod
							Endif
						Endif
						*  
						Insert Into Result ;
							( Name;
							, method;
							, Class;
							, Line;
							, Code ;
							) ;
						values ;
							( lcFileName;
							, lcMethod;
							, lcClass;
							, lnLine;
							, lcCode;
							)
					Endif
				Next
			Endif
		Endscan
		Use In (lcAlias)
		* DBC 
	Case Project.Type=='d'
		Select 0
		Use (lcFileName) Alias (lcAlias) Again
		Select (lcAlias)
		Locate For ObjectType='DataBase' ;
		and ObjectName='StoredProceduresSource'
		
		If Found()
			FindInMemo(Code,lcFindStr)
		Endif
		Use In Select(lcAlias)
		* FRX 
	Case Project.Type=='R'
		*          ?
		*       
		* MNX 
	Case Project.Type=='M'
		*  EditSource     -      
		Select 0
		Use (lcFileName) Alias (lcAlias) Again
		Select (lcAlias)
		Scan All
			If Not Empty(Name)
				FindInMemo(Name,lcFindStr)
			Endif
			If Not Empty(Prompt)
				FindInMemo(Prompt,lcFindStr)
			Endif
			If Not Empty(Command)
				FindInMemo(Command,lcFindStr)
			Endif
			If Not Empty(Procedure)
				FindInMemo(Procedure,lcFindStr)
			Endif
			If Not Empty(Setup)
				FindInMemo(Setup,lcFindStr)
			Endif
			If Not Empty(CleanUp)
				FindInMemo(CleanUp,lcFindStr)
			Endif
		Endscan
		Use In Select(lcAlias)
	Endcase
	Select Project
Endscan
Use In Select(lcProcCursor)
Use In Project
Select Result

Local o

With Createobject("FindForm")
	.Caption=Evaluate(LOC_FORM_CAPTION)
	With .List.ListItems
		Scan All
			o=.Add(,,Name)
			o.ListSubItems.Add(,,Class)
			o.ListSubItems.Add(,,method)
			o.ListSubItems.Add(,,Transform(Line))
			o.ListSubItems.Add(,,Chrtran(Code,Chr(9),""))
			Set Textmerge On To Memvar lcTxt Noshow
			\\EditSource("<<Name>>",<<Line>>,"<<Class>>","<<Method>>")
			Set Textmerge To
			o.Tag=lcTxt
		Endscan
	Endwith
	.Show()
Endwith
Use In Select("Result")

*:********************************************************************
*:
*:	Procedure:	FindInFile
*:
*:********************************************************************
Procedure FindInFile(lcFile, lcStr)
Local k,i, tmp[1]
k=Alines(tmp,Filetostr(lcFile))
For i=1 To k
	If Atc(lcStr,tmp[i])>0
		*   
		Insert Into Result (Name, Line, Code) Values (lcFileName, i, tmp[i])
	Endif
Next

*:********************************************************************
*:
*:	Procedure:	FindInMemo
*:
*:********************************************************************
Procedure FindInMemo(lcMemo, lcStr)
k=Alines(tmp,lcMemo)
For i=1 To k
	If Atc(lcStr,tmp[i])>0
		Insert Into Result (Name, Line, Code) Values (lcFileName, i, tmp[i])
	Endif
Next

*:********************************************************************
*:
*:	Procedure:	Progress
*:
*:********************************************************************
Procedure Progress
Lparameters m.nValue,m.cText,m.cCaption
Local x
x=Createobject("progressform")
With x
	.Value=Iif(Empty(m.nValue),0,m.nValue)
	.Text=Iif(Empty(m.cText),' ',m.cText)
	.Caption=Iif(Empty(m.cCaption),.Caption,m.cCaption)
	.Show()
Endwith
Return x

*         ListVIew -     ?
*   ListBox, Grid -    
*:********************************************************************
*:
*:	Class:		FindForm	based on Form
*:
*:********************************************************************
Define Class FindForm As Form
	Icon=_Screen.Icon
	MDIForm=.T.
	Self=.Null.
	Alias='Result'
	
	Add Object List As OleControl With ;
	OleClass='MSComctlLib.ListViewCtrl.2';
	,BorderStyle=0;
	,FullRowSelect=.F.;
	,HideSelection=.T.;
	,LabelEdit=1 ;
	,LabelWrap=.T.;
	,Top=-1;
	,Left=-1
	
	
	*:********************************************************************
	*:
	*:	Method:	Init of class FindForm
	*:
	*:********************************************************************
	Procedure Init
	With This
		.Self=This
		.Resize()
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	List.Init of class FindForm
	*:
	*:********************************************************************
	Procedure List.Init
	With This
		.Font.Name="MS Sans Serif"
		.Font.Size=8
		.Object.View=3
		.HoverSelection=.T.
		
		With .ColumnHeaders
			.Add(,,LOC_CONTENT,200)
			.Add(,,LOC_CLASS,100)
			.Add(,,LOC_METHOD,100)
			.Add(,,LOC_LINE,60,1)
			.Add(,,LOC_CODE,300)
		Endwith
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	List.DblClick of class FindForm
	*:
	*:********************************************************************
	Procedure List.DblClick()
	With Thisform
		oItem=This.SelectedItem
		
		If Vartype(oItem)='O' And Not Isnull(oItem)
			If Not Empty(oItem.Tag)
				nErr=Evaluate(oItem.Tag)
				If nErr # 0
					Messagebox(Evaluate(LOC_ERR),48,LOC_TITLE)
				Endif
			Endif
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	Resize of class FindForm
	*:
	*:********************************************************************
	Procedure Resize
	With This
		.List.Width=.Width+2
		.List.Height=.Height+2
	Endwith
	
Enddefine

*:********************************************************************
*:
*:	Class:		ProgressBar	based on CommCtrl
*:
*:********************************************************************
Define Class ProgressBar As CommCtrl
	ClassName="msctls_progress32"
	
	Width=350
	Height=18
	
	Min=0
	Max=100
	Step=0
	
	Visible=.T.
	
	*:********************************************************************
	*:
	*:	Method:	Show of class ProgressBar
	*:
	*:********************************************************************
	Procedure Show(oForm)
	With This
		DoDefault(oForm)
		.Min=.Min
		.Max=.Max
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	Min_Assign of class ProgressBar
	*:
	*:********************************************************************
	Procedure Min_Assign(Val)
	With This
		.Min=Val
		.SendMessage(0x0406,.Min,.Max)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	Max_Assign of class ProgressBar
	*:
	*:********************************************************************
	Procedure Max_Assign(Val)
	With This
		.Max=Val
		.SendMessage(0x0406,.Min,.Max)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	SetStep of class ProgressBar
	*:
	*:********************************************************************
	Procedure SetStep(nStep)
	With This
		.Step=nStep
		.SendMessage(0x0404,.Step)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	Clear of class ProgressBar
	*:
	*:********************************************************************
	Procedure Clear
	With This
		.SendMessage(0x0403,0,0)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	StepIp of class ProgressBar
	*:
	*:********************************************************************
	Procedure StepIp
	With This
		.SendMessage(0x0405,0,0)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	BackColor of class ProgressBar
	*:
	*:********************************************************************
	Procedure BackColor(nColor)
	With This
		.SendMessage(0x0409,0,nColor)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	BarColor of class ProgressBar
	*:
	*:********************************************************************
	Procedure BarColor(nColor)
	With This
		.SendMessage(0x2000,0,nColor)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	Value of class ProgressBar
	*:
	*:********************************************************************
	Procedure Value(nValue)
	With This
		nValue=nValue*100
		If Between(nValue,.Min,.Max)
			.SendMessage(0x0402,nValue,0)
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	VFPStatusHwnd of class ProgressBar
	*:
	*:********************************************************************
	Procedure VFPStatusHwnd
	With This
		If Set("Status Bar")="ON"
			Local x, buf, T,l,r,b
			buf=Replicate(Chr(0),16)
			GetClientRect(_vfp.HWnd,@buf)
			
			l=.C2B(Substr(buf,1,4))
			T=.C2B(Substr(buf,5,4))
			r=.C2B(Substr(buf,9,4))
			b=.C2B(Substr(buf,13,4))
			
			x=ChildWindowFromPoint(_vfp.HWnd,0,b-T-1)
			Return x
		Endif
		Return 0
	Endwith
Enddefine

*:********************************************************************
*:
*:	Class:		CommCtrl	based on Custom
*:
*:********************************************************************
Define Class CommCtrl As Custom
	Visible=.T.
	ClassName=""
	
	ThisHWND=0
	ParentHWND=0
	
	Style=0
	
	*:********************************************************************
	*:
	*:	Method:	Init of class CommCtrl
	*:
	*:********************************************************************
	Procedure Init
	With This
		.LoadDLLS()
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	Show of class CommCtrl
	*:
	*:********************************************************************
	Procedure Show(oForm)
	With This
		.CreateWindow(oForm)
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	CreateWindow of class CommCtrl
	*:
	*:********************************************************************
	Procedure CreateWindow(oParentForm)
	With This
		If Not Empty(.ThisHWND)
			DestroyWindow(.ThisHWND)
		Endif
		.GetParentHWND(oParentForm)
		
		nInstance=GetWindowLong( .ParentHWND, (-6))
		
		
		.ThisHWND=CreateWindowEx;
		(0x00000004;
		,.ClassName;
		,.Name;
		, 0x40000000+0x10000000+.Style;
		,.Left;
		,.Top;
		,.Width;
		,.Height;
		,.ParentHWND;
		,0;
		,nInstance;
		,0)
		
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	GetParentHWND of class CommCtrl
	*:
	*:********************************************************************
	Procedure GetParentHWND(oForm)
	With This
		If Empty(.ParentHWND)
			If Vartype(oForm)='O'
				.ParentHWND=oForm.HWnd
			Else
				.ParentHWND=Thisform.HWnd
			Endif
		Endif
		Return .ParentHWND
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	SendMessage of class CommCtrl
	*:
	*:********************************************************************
	Procedure SendMessage( Msg, Lparam, wParam )
	With This
		If Not Empty(.ThisHWND)
			If Vartype(wParam)="C"
				SendString(.ThisHWND,Msg,Lparam, wParam)
			Else
				SendMessage(.ThisHWND,Msg,Lparam, wParam)
			Endif
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	Destroy of class CommCtrl
	*:
	*:********************************************************************
	Procedure Destroy
	With This
		If Not Empty(.ThisHWND)
			DestroyWindow(.ThisHWND)
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*:	Method:	C2B of class CommCtrl
	*:
	*:********************************************************************
	Procedure C2B( m.str)
	Local N, i
	N=0
	For i=Len(m.str) To 1 Step -1
		N=Bitlshift(N,8)+Asc(Substr(m.str,i,1))
	Next
	Return N
	
	
	*:********************************************************************
	*:
	*:	Method:	LoadDLLS of class CommCtrl
	*:
	*:********************************************************************
	Procedure LoadDLLS
	Declare Integer LoadLibraryEx In Win32API ;
	String @ lpFileName, ;							&& file name of module
	Integer hFile, ;								&& reserved, must be NULL
	Integer dwFlags									&& entry-point execution option
	
	Declare Integer FreeLibrary In Win32API ;
	Integer hModule									&& handle to DLL module
	
	Declare Integer ChildWindowFromPoint In Win32API ;
	Integer	hWndParent, ;							&& handle to parent window
	Integer	nX, ;
	Integer nY
	
	Declare Integer SetParent In Win32API ;
	Integer, ;										&& handle to window
	Integer											&& new parent window
	
	Declare Integer CreateWindowEx In user32 ;
	Integer	dwExStyle, ;							&& extended window style
	String @lpClassName, ;							&& address of registered class name
	String @lpWindowName, ;							&& address of window name
	Long	dwStyle, ;								&& window style
	Integer	x, ;									&& horizontal position of window
	Integer	Y, ;									&& vertical position of window
	Integer	nWidth,	;								&& window width
	Integer nHeight, ;								&& window height
	Integer hWndParent, ;							&& handle of parent or owner window
	Integer	hMenu, ;								&& handle of menu or child-window identifier
	Integer	hInstance, ;							&& handle of application instance
	Long	lpParam 								&& address of window-creation data
	
	Declare Integer	IsWindow In Win32API ;
	Integer	HWnd 									&& handle of window
	
	Declare Integer DestroyWindow In Win32API ;
	Integer HWnd									&& handle of window to destroy
	
	Declare Integer	SendMessage In Win32API ;
	Integer	HWnd,;									&& handle of destination window
	Integer	uMsg, ;									&& message to send
	Integer	wParam,;								&& first message parameter
	Long	Lparam 									&& second message parameter
	
	Declare Integer ShowWindow In Win32API ;
	Integer	HWnd, ;									&& handle of window
	Integer	nCmdShow								&& show state of window
	
	Declare Integer SetFocus In Win32API ;
	Integer HWnd
	
	Declare Integer GetFocus In Win32API
	
	Declare Integer GetLastError In Win32API
	
	Declare Long GetWindowLong In Win32API ;
	Integer	HWnd, ;									&& handle of window
	Integer	nIndex									&& offset of value to retrieve
	
	Declare Integer GetClientRect In Win32Api ;
	Integer HWnd,;
	String @ Rect
	
	
	Declare Integer	SendMessage In Win32API ;
	Integer	HWnd,;									&& handle of destination window
	Integer	uMsg, ;									&& message to send
	Integer	wParam,;								&& first message parameter
	Long	Lparam 									&& second message parameter
	
	Declare Integer	SendMessage In Win32API As SendString ;
	Integer	HWnd,;									&& handle of destination window
	Integer	uMsg, ;									&& message to send
	Integer	wParam,;								&& first message parameter
	String @ Lparam 								&& second message parameter
	
Enddefine


*:********************************************************************
*:
*:	Class:		ProgressForm	based on Form
*:
*:********************************************************************
Define Class ProgressForm As Form
	AlwaysOnTop=.T.
	MinButton=.F.
	MaxButton=.F.
	Closable=.F.
	ControlBox=.F.
	BorderStyle=2
	AutoCenter=.T.
	Caption=' '
	Width=300
	Height=100
	Desktop=.T.
	
	TEXT=""
	Value=0
	
	add object label as label with ;
	fontname=_fontname,;
	fontsize=8,;
	alignment=2,;
	wordwrap=.t.,;
	top=5,;
	left=5,;
	width=290,;
	height=40,;
	caption=' ',;
	autosize=.f.
	
	*:********************************************************************
	*:
	*:	Method:	Init of class ProgressForm
	*:
	*:********************************************************************
	Procedure Init( m.nValue, m.cText, m.cCaption)
	with this
		.addobject('progress','progressbar')
		with .progress
			.top=70
			.left=10
			.width=this.width-21
			.height=20
			.visible=.t.
			*			.style=1
			.show()
		endwith
		
		if vartype(m.cText)='C'
			.text=m.cText
		endif
		if vartype(m.cCaption)='C'
			.caption=m.cCaption
		endif
	endwith
	
	*:********************************************************************
	*:
	*:	Method:	text_assign of class ProgressForm
	*:
	*:********************************************************************
	Procedure text_assign( m.text )
	with this.label
		.top=5
		.left=5
		.width=290
		.height=40
		.caption=iif(vartype(m.text)="C",m.text,tran(m.text,""))
		*		.autosize=.t.
	endwith
	
	*:********************************************************************
	*:
	*:	Method:	value_assign of class ProgressForm
	*:
	*:********************************************************************
	Procedure value_assign( m.val )
	with this
		.progress.value(m.val)
	endwith
	
enddefine

*: End of : findproj.prg
